<template>
  <div class="card">
    <div class="card-header">
      <i class="icon" :class="meal.$data.icon" />
      <span class="title">{{ meal.title }}</span>
      <p class="sum font-7 mt-2">
        <span class="text-muted">کالری وعده</span>
        <span class="text-green-light">{{ meal.totalCalories }}</span>
      </p>
    </div>
    <div class="card-body">
      <div class="actions">
        <button class="btn btn-danger" @click="$emit('add')">
          <i class="ic-plus" />
        </button>
        <!--<button class="btn btn-outline-danger">
          <i class="ic-food-basket" />
        </button>-->
      </div>
      <touch-scroll
        v-if="ready"
        ref="touchScroll"
        class="meal-foods"
        :width="meal.foods.length * 106"
      >
        <div data-class="transition-group">
          <div v-for="food in meal.foods" :key="food.id" class="meal-food">
            <food-item
              :key="`${food.id}_${food.foodId}_${food.unitId}_${food.amount}`"
              :ref="`foodItem_${food.foodId}`"
              :food="food"
              @show-me="showItem(food.foodId)"
            />
          </div>
        </div>
      </touch-scroll>
    </div>
  </div>
</template>

<script>
import FoodItem from './FoodItem'
import TouchScroll from '../helper/TouchScroll'
export default {
  name: 'MealItem',
  components: { FoodItem, TouchScroll },
  props: {
    meal: { type: Object, default: () => ({}) },
    index: { type: Number, default: 0 }
  },
  data() {
    return {
      ready: false,
      foods: []
    }
  },
  mounted() {
    setTimeout(() => {
      this.ready = true
    }, 700 * this.index)
  },
  methods: {
    showItem(foodId) {
      this.$nextTick(() => {
        let foodEl = this.$refs[`foodItem_${foodId}`]
        let touchScroll = this.$refs.touchScroll
        if (!foodEl || !touchScroll) return
        touchScroll.iScroll.scrollToElement(foodEl[0].$el, 500)
      })
    }
    // @todo : we can add some animations here
    // showing the foods by timeout
    // transitionBeforeEnter: function(el) {
    //   el.style.opacity = 0
    //   el.style.height = 0
    // },
    // transitionEnter: function(el, done) {
    //   var delay = el.dataset.index * 150
    //   setTimeout(function() {
    //     Velocity(el, { opacity: 1, height: '1.6em' }, { complete: done })
    //   }, delay)
    // },
    // transitionLeave: function(el, done) {
    //   var delay = el.dataset.index * 150
    //   setTimeout(function() {
    //     Velocity(el, { opacity: 0, height: 0 }, { complete: done })
    //   }, delay)
    // }
  }
}
</script>
